function A=randnherpd(N,d,varargin)
% FUNCTION fc_amat.random.randnherpd
% -- randnherpd(N,d)
%      Return a N-by-d-by-d amat object with hermitian positive definite
%      matrices generate from fc_amat.random.randnsdd function.
%
% -- randnsympd(...,key, value)
%      Optional key/value pairs are those of the fc_amat.random.randnsdd 
%      function except 'complex' which is forced to true.
%        - 'class', value can be 'single' or 'double' (default).
%        - 'mean', to set mean value (0 by default).
%        - 'sigma', to set standard deviation value (1 by default).
%
%      See also: fc_amat.random.randnsympd, fc_amat.random.randn
%                class amat, randn
%
  A=fc_amat.random.randnsdd(N,d,'complex',true,varargin{:}); % generate N regular d-by-d matrices (as stricly diagonally dominante matrices)
  A=A'*A;
end
