function [Inputs,Bdatas,Errors]=setLU01(in,verbose,varargin)
  p = inputParser;
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.parse(varargin{:});
  R=p.Results;
  Fprintf=R.fprintf;
  m=in;
  A=randn(m,m); % A is the input of the LU functions
  Errors{1}=@(L,U,P) norm(L*U-P*A,Inf);
  if verbose
    Fprintf('# Prototype functions without wrapper: [L,U,P]=fun(A)\n',class(A))
    Fprintf('# Input parameter A: m-by-n matrix [%s]\n',class(A))
    Fprintf('# Outputs are [L,U,P] such that P*A=L*U\n')
    Fprintf('# Error[i] computed with fun[i] outputs :\n#   %s\n',func2str(Errors{1}))
  end
  Bdatas{1}=fc_bench.bdata('m',m,'%d',7);
  Inputs={A}; 
end
