function varargout=plot(q,me,u,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('type','simplicial');
  p.parse(varargin{:});
  R=p.Results;
  U=fc_meshtools.eval(u,q);
  assert(length(U)==size(q,2));
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  varargin=fc_tools.graphics.xcolor.set_xcolors_varargin(varargin);
  if strcmp(R.type,'simplicial')
    dim=size(q,1);d=size(me,1)-1;
    H=[];
    eval(sprintf('H=PlotSubTh%dsimp%dD(q,me,U,varargin{:});',d,dim));
  else
    error('Unknow type ''%s''',R.type)
  end
  if nargout==1,varargout{1}=H;end
end

function h=PlotSubTh3simp3D(q,me,U,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlane',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlane;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  nq=size(q,2);
  
  view(3)
  idxme=fc_graphics4mesh.cutIndex(q,me,P);
  % h=scatter3(q(1,:),q(2,:),q(3,:),self.get_h(),U); % Nuage de points. Tres lent sous Octave
  idx=nchoosek(1:4,2);
  % To optimize
  for i=1:size(idx,1)
    if fc_tools.comp.isOctave()
      [Q,ME,V]=PatchOctave(q,me,U,idx(i,:),idxme);
      h(i)=patch('Vertices',Q,'Faces',ME,'facevertexcdata',V,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    else
      h(i)=patch('Vertices',q','Faces',me(idx(i,:),idxme)','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    end
  end
end

function h=PlotSubTh2simp3D(q,me,U,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlane',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlane;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  idxme=fc_graphics4mesh.cutIndex(q,me,P);
  nq=size(q,2);
  view(3)
  h=patch('Vertices',q','Faces',me(:,idxme)','facevertexcdata',U,'FaceColor','interp',PlotOptions{:});%'FaceColor','interp');%,'FaceColor','none','LineWidth',2)
end

function h=PlotSubTh1simp3D(q,me,U,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('cutPlane',[]);
  p.parse(varargin{:});
  P=p.Results.cutPlane;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  idxme=fc_graphics4mesh.cutIndex(q,me,P);
  
  view(3)
  if fc_tools.comp.isOctave()
    [Q,ME,V]=PatchOctave(q,me,U,1:2,idxme);
    h=patch('Vertices',Q,'Faces',ME,'facevertexcdata',V,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
  else
    h=patch('Vertices',q','Faces',me(:,idxme)','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
  end
end

function h=PlotSubTh2simp2D(q,me,u,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('plane',false);
  p.parse(varargin{:});
  R=p.Results;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  if R.plane
      h=patch('Vertices',q','Faces',me','facevertexcdata',u,'FaceColor','interp',PlotOptions{:});
  else
    h=trisurf(me',q(1,:),q(2,:),u,PlotOptions{:});
  end
end

function h=PlotSubTh1simp2D(q,me,U,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('plane',false);
  p.parse(varargin{:});
  R=p.Results;
  PlotOptions=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  
  if fc_tools.comp.isOctave()
    [Q,ME,V]=PatchOctave(q,me,U,1:2);
    if R.plane
      h=patch('Vertices',Q,'Faces',ME,'facevertexcdata',V,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    else
      h=patch('Vertices',[Q,V],'Faces',ME,'facevertexcdata',V,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    end
  else  
    if R.plane
      h=patch('Vertices',q','Faces',me','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    else
      h=patch('Vertices',[q',U],'Faces',me','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    end
  end
end

function h=PlotSubTh1simp1D(q,me,U,varargin)
  [qs,Ind]=sort(q);
  h=plot(qs,U(Ind),varargin{:});
end

% 
function [Q,ME,V]=PatchOctave(q,me,U,id,idxme)
  if nargin==4,idxme=1:size(me,2);end
  nq=size(q,2);
  Qeps=q;
  %Qeps(1,:)=Qeps(1,:)+10*eps/self.h;
  Qeps(1,:)=Qeps(1,:)+10*eps;
  Q=[q,Qeps]';
  if nargin==3, ME=me(id,:);else ME=me(id,idxme);end
  ME=[ME;ME(1,:)+nq]';
  V=[U;U];
end
