function varargout=bench(d,LN,varargin)
  % fc_hypermesh.benchs.bench(3,100:50:300,'type','orthotope');
  % fc_hypermesh.benchs.bench(3,50:25:150,'type','orthotope','box',[-2,2;-1,1;0,2],'order',2);
  p = inputParser;
  p.addParamValue('type', 'simplex', @(x) ismember(x,{'simplex','orthotope'}) );
  p.addParamValue('box', [zeros(d,1),ones(d,1)], @(x) (sum(size(x)==[d,2])==2) );
  p.addParamValue('m_min', 0, @(x) (x<=d) && (x>=0) );
  p.addParamValue('order', 1 );
  p.addParamValue('mapping', []);
  p.parse(varargin{:});
  R=p.Results;
  Lfun={ @(varargin) fc_hypermesh.OrthMesh(varargin{:}) }; % function to benchmark
  
  % columns just after cputime column
  after={ {fc_bench.bdata('Mem.(MB)',@(Oh) Oh.get_memory()/((1024)^2),'%.2f',10)} };
  setfun=@(N,verbose,varargin) fc_hypermesh.benchs.setOrthMesh({d,N},verbose,'type',R.type,'box',R.box,'order',R.order);
  %keyboard
  Res=fc_bench.bench(Lfun,setfun,LN,'after',after);
  
  if nargout==1
    varargout{1}=Res;
  end
end
