function varargout=gpdemo02(varargin)
  % pGh=fc_oogmsh.demos.gpdemo('geofile','condenser','d',2,'MshFileVersion','4.1','physical',false,'np',5);
  % pGh=fc_oogmsh.demos.gpdemo('geofile','cylinderkey','d',3,'np',5,'graphic',true);
  % pGh=fc_oogmsh.demos.gpdemo('geofile','demisphere4surf','d',2,'np',5,'graphic',true);
  formats=fc_oogmsh.gmsh.getMSHfile_formats();
  p = inputParser;
  p.addParamValue('geofile','condenser',@ischar);
  p.addParamValue('MshFileVersion','4.1',@(x) ismember(x,formats));
  p.addParamValue('N',4,@isscalar);
  p.addParamValue('d',2,@isscalar);
  p.addParamValue('np',5,@(x) isscalar(x) && (x>=2) ); % number of partitions 
  p.addParamValue('graphic',true,@islogical);
  %p.addParamValue('verbose',true,@islogical);
  p.parse(varargin{:});
  R=p.Results;
  %varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  if R.graphic,close all;end
  
  fprintf('1. Building a mesh file by using :\n')
  fprintf('   -> gmsh version %s\n',fc_oogmsh.gmsh.version())
  fprintf('   -> geo file : %s\n',R.geofile);
  fprintf('   -> mesh file format : %s\n',R.MshFileVersion);
  meshfile=fc_oogmsh.gmsh.buildmesh(R.geofile,R.N,'d',R.d,'verbose',1,'force',true,'MshFileVersion',R.MshFileVersion);
  fprintf('   -> msh file : %s\n',fc_oogmsh.pathrep(meshfile));
  fprintf('2. Building partitioned mesh file\n')
  fprintf('   -> number of partitions : %d\n',R.np);
  pmfile=fc_oogmsh.gmsh.buildpartmesh(meshfile,R.np,'verbose',1,'force',true,'MshFileVersion',R.MshFileVersion);
  fprintf('   -> partitioned msh file : %s\n',fc_oogmsh.pathrep(pmfile));
  fprintf('3. Reading the partitioned mesh file\n')
  if strcmp(R.MshFileVersion,'2.2')
    pGh=fc_oogmsh.ooGmsh2(pmfile);
  else
    pGh=fc_oogmsh.ooGmsh4(pmfile);
  end
  fprintf('   -> Mesh file format: %s\n',pGh.MeshFormat.version);
  if R.graphic
    pGh.plotPhysicalElements()
    pGh.plotElementaryElements()
    pGh.plotPartitionElements()
    pGh.plotInterfaceElements()  
    fc_tools.graphics.monitors.autoGrid()
  end
  if nargout==1,varargout{1}=pGh;end
end
