function Nodes=read_Nodes(fid,varargin)
  p = inputParser;
  p.addParamValue('verbose',false,@islogical);
  p.parse(varargin{:});
  verbose=p.Results.verbose;
  
  flag=fc_oogmsh.msh.find_section(fid,'$Nodes',varargin{:});
  R=fscanf(fid,'%d',2);
  numEntityBlocks=R(1);numNodes=R(2);
  
  EntityBlocks=struct('entityTag',[],'entityDim',[],'parametric',[],'numNodes',[],'nodeTags',[],'Nodes',[]); % Nodes are (x,y,z)
  
  EntityBlocks=repmat(EntityBlocks,1,numEntityBlocks);
  minNodeTag=10^6;maxNodeTag=0; % Missing in 4.0 version but present in 4.1
  for i=1:numEntityBlocks
    %text = fgetl ( fid );
    R=fscanf(fid,'%d',4)';
    EntityBlocks(i).entityTag=R(1);EntityBlocks(i).entityDim=R(2);
    EntityBlocks(i).parametric=R(3);EntityBlocks(i).numNodes=R(4);
    V=fscanf(fid,'%g',4*R(4)); % tag x y z
    % u and v?
    V=reshape(V,4,R(4));
    EntityBlocks(i).nodeTags=V(1,:);
    EntityBlocks(i).Nodes=V(2:4,:);
    minNodeTag=min([min(EntityBlocks(i).nodeTags),minNodeTag]);
    maxNodeTag=max([max(EntityBlocks(i).nodeTags),maxNodeTag]);
  end
 
  text = fscanf(fid,'%s',1);
  if ( text == -1 ) | ~strcmp(strtok(text),'$EndNodes') 
    error('Trouble when reading file in section $Nodes %s',text)
  else
    if verbose,fprintf('Reading $Nodes section seem OK\n');end
  end
  Nodes=struct('numEntityBlocks',numEntityBlocks, 'numNodes',numNodes, ...
               'minNodeTag',minNodeTag, 'maxNodeTag',maxNodeTag, ...
               'EntityBlocks',EntityBlocks);
end
